\NeedsTeXFormat{LaTeX2e}[1994/06/01]
\ProvidesPackage{warmachine}[2018/13/03 Custom Package]

%% required packages
\RequirePackage[english,italian]{babel}  % languages
\RequirePackage[T1]{fontenc}
\RequirePackage[utf8x]{inputenc}
\RequirePackage{graphicx}  % pacchetto grafica
\RequirePackage[a4paper,top=3cm,bottom=3cm,left=2.5cm,right=2.5cm,head=30pt,foot=30pt]{geometry}
\RequirePackage{url}
\RequirePackage{enumerate}
\RequirePackage{booktabs}
\RequirePackage{tabularx}
\RequirePackage{subfiles}
\RequirePackage[bookmarks=true,hyperfootnotes=false,colorlinks=true]{hyperref}
	\hypersetup{
  		colorlinks,
  		citecolor=gray,
  		filecolor=brown,
  		linkcolor=black,
  		urlcolor=blue
	}
\RequirePackage{fancyhdr}
\RequirePackage{longtable}
\RequirePackage{appendix}
\RequirePackage{caption}
\RequirePackage{tabu}
\RequirePackage{pifont}
\RequirePackage[official]{eurosym}
\RequirePackage[table]{xcolor}
\RequirePackage{float}
\RequirePackage{amsmath}
\RequirePackage{tabularx, booktabs}
\RequirePackage{lastpage}  % per avere ultima pagina
\RequirePackage{ragged2e}  % justify text
\RequirePackage{xcolor}
\RequirePackage{xspace}
\RequirePackage{listings}
\RequirePackage{newclude}
\RequirePackage{enumitem}
\RequirePackage{longtable}
\RequirePackage[figure,table]{totalcount}
\RequirePackage{multirow}

\newcolumntype{s}{>{\hsize=.21\hsize}X}
\newcolumntype{f}{>{\hsize=.37\hsize}X}
\newcolumntype{m}{>{\hsize=.42\hsize}X}

\captionsetup{tableposition=top,figureposition=bottom,font=small}
\captionsetup{format=hang,labelfont={sf,bf}}
\captionsetup[table]{position=bottom}
\newcolumntype{C}{>{\centering\arraybackslash}X}
\renewcommand{\arraystretch}{1.20}	% increase tab padding

%% custom commands
% general purpose
\newcommand{\nb}[1]{\textbf{NB:}\xspace #1}

% names
\newcommand{\wm}{\textit{WarMachine}\xspace}
\newcommand{\vardanega}{\textit{Prof. Vardanega Tullio}\xspace}
\newcommand{\cardin}{\textit{Prof. Cardin Riccardo}\xspace}
\newcommand{\rawmail}{warmachine.swe@gmail.com}
\newcommand{\mail}[1]{\href{mailto:#1}{\texttt{#1}}}
\newcommand{\mailus}{\mail{\rawmail}}
\newcommand{\progetto}{\textit{IronWorks}\xspace}
\newcommand{\committente}{\vardanega e \cardin\xspace}
\newcommand{\fornitore}{\textit{WarMachine}\xspace}
\newcommand{\proponente}{\textit{Zucchetti s.p.a}\xspace}
\newcommand{\unipd}{Università degli Studi di Padova\xspace}
\newcommand{\distribuzioneInterna}{\wm\xspace}
\newcommand{\distribuzioneEsterna}{\vardanega\\ &\cardin\\ &\proponente}

% team members
\newcommand{\ile}{Zanetti Ilenia\xspace}
\newcommand{\ele}{Zanon Elena\xspace}
\newcommand{\andrea}{Coletti Andrea\xspace}
\newcommand{\foga}{Fogarollo Stefano\xspace}
\newcommand{\leo}{Bragagnolo Leonardo\xspace}
\newcommand{\shiro}{Cisternino Nicola\xspace}
\newcommand{\ric}{Bernucci Riccardo\xspace}

% roles
\newcommand{\rdp}{\textit{Responsabile di progetto}\xspace}
\newcommand{\amm}{\textit{Amministratore}\xspace}
\newcommand{\anl}{\textit{Analista}\xspace}
\newcommand{\pro}{\textit{Progettista}\xspace}
\newcommand{\dev}{\textit{Programmatore}\xspace}
\newcommand{\ver}{\textit{Verificatore}\xspace}
\newcommand{\sgr}{\textit{Segretario}\xspace}
\newcommand{\rdt}{\textit{Redattore}\xspace}
% (plurals)
\newcommand{\ammi}{\textit{Amministratori}\xspace}
\newcommand{\anli}{\textit{Analisti}\xspace}
\newcommand{\proi}{\textit{Progettisti}\xspace}
\newcommand{\prgi}{\textit{Programmatori}\xspace}
\newcommand{\veri}{\textit{Verificatori}\xspace}
\newcommand{\sgri}{\textit{Segretari}\xspace}

% docs
\newcommand{\pdp}{\textit{Piano di progetto}\xspace}
\newcommand{\pdq}{\textit{Piano di qualifica}\xspace}
\newcommand{\np}{\textit{Norme di progetto}\xspace}
\newcommand{\sdf}{\textit{Studio di fattibilità}\xspace}
\newcommand{\adr}{\textit{Analisi dei requisiti}\xspace}
\newcommand{\st}{\textit{Specifica tecnica}\xspace}
\newcommand{\ddp}{\textit{Definizione di prodotto}\xspace}
\newcommand{\mdu}{\textit{Manuale utente}\xspace}
\newcommand{\ms}{\textit{Manuale sviluppatore}\xspace}
\newcommand{\glo}{\textit{Glossario}\xspace}
\newcommand{\verbale}{\textit{Verbale}\xspace}
\newcommand{\pb}{\textit{Product Baseline - Allegato \\tecnico}\xspace}

% versioned docs
\newcommand{\pdpv}{\textit{Piano di progetto v4.0.0}\xspace}
\newcommand{\pdqv}{\textit{Piano di qualifica v4.0.0}\xspace}
\newcommand{\npv}{\textit{Norme di progetto v4.0.0}\xspace}
\newcommand{\sdfv}{\textit{Studio di fattibilità v1.0.0}\xspace}
\newcommand{\adrv}{\textit{Analisi dei requisiti v4.0.0}\xspace}
\newcommand{\msv}{\textit{Manuale sviluppatore v2.0.0}\xspace}
\newcommand{\muv}{\textit{Manuale utente v2.0.0}\xspace}
\newcommand{\glov}{\textit{Glossario v3.0.0}\xspace}

% revisions
\newcommand{\revisionedeirequisiti}{\textbf{Revisione dei Requisiti}\xspace}
\newcommand{\revisionediaccettazione}{\textbf{Revisione di Accettazione}\xspace}
\newcommand{\revisionediprogettazione}{\textbf{Revisione di Progettazione}\xspace}
\newcommand{\revisionediqualifica}{\textbf{Revisione di Qualifica}\xspace}

% test state pdq
\newcommand{\spr}{
	\begin{center}
	\textbf{\color{green}{\footnotesize{Superato}}}\xspace
	\end{center}
}
\newcommand{\nots}{\textbf{Non superato}\xspace}
\newcommand{\impl}{\textbf{Implementato}\xspace}
\newcommand{\noti}{\textbf{Non implementato}\xspace}

%% colors
\definecolor{ironManDark}{HTML}{6A0C0B}  % official iron man color
\definecolor{ironManLight}{HTML}{AA0505}
\definecolor{linegray}{HTML}{969669} 
\definecolor{codeBoxMan}{HTML}{D9D9D9} % background's color for box code snippets examples in manuals
\newcommand{\colorTableRows}{ironManLight!50}
\newcommand{\colorTableTitle}{ironManDark!50}

% manuals code snippet's box
\newcommand{\codeBox}[1]{
		\texttt{#1}
}
% pdq description tests
% @param = test's description's text
\newcommand{\testBoxD}[1]{
	\begin{center}
		\footnotesize{#1}
	\end{center}
}
% pdq code tests
% @param = test's code's text
\newcommand{\testBoxC}[1]{
	\begin{center}
	\footnotesize{\textbf{#1}}
	\end{center}
}

% glossary
\newcommand{\gl}[1]{#1\ped{\ped{G}}} % e.g questo \gl{termine} va inserito
\newcommand{\todo}{\colorbox{red}{\textbf{TODO!!!}}}

% use cases
\newcommand{\uc}[1]{\textbf{UC#1}\xspace}
\newcommand{\actp}{\textbf{Attori primari:}\xspace}
\newcommand{\acts}{\textbf{Attori secondari:}\xspace}
\newcommand{\desc}{\textbf{Scopo e descrizione:}\xspace}
\newcommand{\pre}{\textbf{Precondizioni:}\xspace}
\newcommand{\post}{\textbf{Postcondizioni:}\xspace}
\newcommand{\scep}{\textbf{Scenario principale:}\xspace}
\newcommand{\scea}{\textbf{Scenario alternativo:}\xspace}

%% layouts

% add meta data
\newcommand{\meta}{
	% \author{\wm}
	\pagestyle{fancy}
	\fancyhf{}
}

% generates footer and header
\newcommand{\intestazioni}[2]{
	% header personalizzato
	\renewcommand{\headrulewidth}{0.1pt}
	\lhead{\includegraphics[scale=0.05]{#2}}
	\fancyhead[R]{\slshape \MakeUppercase{\rightmark}}

	% footer personalizzato
	\renewcommand{\footrulewidth}{0.1pt}
	\lfoot{#1}
	\rfoot{Pagina \thepage\ di \pageref{LastPage}}
}

% generates main title in front page
\newcommand{\copertina}[2]{
	\intestazioni{#1}{#2}
	\title{
		\huge{
			\begin{figure}[H]
				\centering{
					\includegraphics[scale=0.35]{#2}
				}
			\end{figure}
			\vspace{5pt}
			\centering{
				\Huge{
					\textbf{{#1}}\\
					\vspace{2pt}
				}
				\Huge{
					\large{\textit{\textbf{\wm \xspace-- Progetto \progetto}}}\\
					\normalsize{\rawmail}
				}
			}
		}
	}
	\date{}  % remove date
}

% generates info table about doc
\newcommand{\infodoc}[7]{
	\centering{\bfseries Informazioni sul documento:\\}
	\vspace{0.5cm}
	\begin{tabular}{r|l}
	    {\hfill \textbf{Versione}} & #1\\
	    {\hfill \textbf{Data di creazione}} & #2\\
	    {\hfill \textbf{Redazione}} & #3\\
	    {\hfill \textbf{Verifica}} & #4\\
	    {\hfill \textbf{Approvazione}} & #5\\
	    {\hfill \textbf{Uso}} & #6\\
	    {\hfill \textbf{Distribuzione}} & #7\\
	\end{tabular}\\
	\clearpage
}

% generates edit history
\newcommand{\diarioModificheStart}{
	\vspace*{5pt}
	\section*{Diario delle modifiche}  % \todo edit info

	\centering
    % \rowcolors{2}{\colorTableRows}{white}
	\begin{longtable}[H]{ l | l | l | l | >{\centering}p{3.1cm} }
	    \renewcommand {\arraystretch}{1.3} 
	    \label{versioniDocumento}
	    \textbf{Versione} & \textbf{Data} & \textbf{Collaboratori} & \textbf{Ruolo} & \textbf{Descrizione} \tabularnewline \hline
}

% adds new version in edit history
\newcommand{\diarioModificheNew}[5]{
	#1 & #2 & #3 & #4 & #5 \tabularnewline \hline
}

% generates verbale edit history
\newcommand{\diarioModificheVerbaleStart}{
	\vspace*{5pt}
	\section*{Diario delle modifiche}  % \todo edit info

	\centering
    % \rowcolors{2}{\colorTableRows}{white}
	\begin{longtable}[H]{ l | l  >{\centering}p{3.1cm} }
	    \renewcommand {\arraystretch}{1.3} 
	    \label{versioniDocumento}
	    \textbf{Data} & \textbf{Redattore}
	    \tabularnewline \hline
}

% adds new version in verbale edit history
\newcommand{\diarioModificheVerbaleNew}[5]{
	#1 & #2 & #3 & #4 & #5 \tabularnewline \hline
}

% indeces
\newcommand{\makeallindex}{
 	\tableofcontents
	\iftotalfigures\listoffigures\fi  % don't show if there are none
	\iftotaltables\listoftables\fi
}

% ends edit history
\newcommand{\diarioModificheEnd}{
	\end{longtable}
	\addtocounter{table}{-1}

	\clearpage
	\makeallindex
}

% to get \subsubsubsection
\setcounter{tocdepth}{5}
\setcounter{secnumdepth}{5}

% inner sub-sections
\newcommand{\subsubsubsection}[1]{\paragraph{#1}~\\}

\renewcommand\subparagraph{
	\@startsection{subparagraph}{5}{\z@ }{
	3.25ex \@plus 1ex \@minus .2ex}{-2em}
	{\normalfont \normalsize \bfseries }
}
\newcommand{\subsubsubsubsection}[1]{\subparagraph{#1}~\\}


\endinput
